<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns="http://www.w3.org/1999/xhtml"
                              xmlns:html="http://www.w3.org/1999/xhtml"
                              xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:msxsl="urn:schemas-microsoft-com:xslt"
                              xmlns:wwmode="urn:WebWorks-Engine-Mode"
                              xmlns:wwdoc="urn:WebWorks-Document-Schema"
                              xmlns:wwsplits="urn:WebWorks-Engine-Splits-Schema"
                              xmlns:wwproject="urn:WebWorks-Publish-Project"
                              xmlns:wwlog="urn:WebWorks-XSLT-Extension-Log"
                              xmlns:wwprojext="urn:WebWorks-XSLT-Extension-Project"
                              xmlns:wwunits="urn:WebWorks-XSLT-Extension-Units"
                              xmlns:wwexsldoc="urn:WebWorks-XSLT-Extension-Document"
                              exclude-result-prefixes="xsl msxsl wwmode wwdoc wwproject wwlog wwprojext wwunits wwexsldoc"
>
 <xsl:import href="wwtransform:super" />


 <xsl:template match="wwdoc:Paragraph[@stylename = 'ErrorList2']" mode="wwmode:content">
  <xsl:param name="ParamSplits" />
  <xsl:param name="ParamCargo" />
  <xsl:param name="ParamLinks" />
  <xsl:param name="ParamTOCData" />
  <xsl:param name="ParamSplit" />

  <xsl:call-template name="Paragraph-Tabs-To-Text">
   <xsl:with-param name="ParamParagraph" select="." />
   <xsl:with-param name="ParamCellWidth" select="''" />
   <xsl:with-param name="ParamSplits" select="$ParamSplits" />
   <xsl:with-param name="ParamCargo" select="$ParamCargo" />
   <xsl:with-param name="ParamLinks" select="$ParamLinks" />
   <xsl:with-param name="ParamTOCData" select="$ParamTOCData" />
   <xsl:with-param name="ParamSplit" select="$ParamSplit" />
  </xsl:call-template>
 </xsl:template>

 <xsl:template match="wwdoc:Paragraph[@stylename = 'BodyContents1']" mode="wwmode:content">
  <xsl:param name="ParamSplits" />
  <xsl:param name="ParamCargo" />
  <xsl:param name="ParamLinks" />
  <xsl:param name="ParamTOCData" />
  <xsl:param name="ParamSplit" />

  <xsl:call-template name="Paragraph-Tabs-To-Text">
   <xsl:with-param name="ParamParagraph" select="." />
   <xsl:with-param name="ParamCellWidth" select="'300px'" />
   <xsl:with-param name="ParamSplits" select="$ParamSplits" />
   <xsl:with-param name="ParamCargo" select="$ParamCargo" />
   <xsl:with-param name="ParamLinks" select="$ParamLinks" />
   <xsl:with-param name="ParamTOCData" select="$ParamTOCData" />
   <xsl:with-param name="ParamSplit" select="$ParamSplit" />
  </xsl:call-template>
 </xsl:template>

 <xsl:template match="wwdoc:Paragraph[@stylename = 'BodyContents']" mode="wwmode:content">
  <xsl:param name="ParamSplits" />
  <xsl:param name="ParamCargo" />
  <xsl:param name="ParamLinks" />
  <xsl:param name="ParamTOCData" />
  <xsl:param name="ParamSplit" />

  <xsl:call-template name="Paragraph-Tabs-To-Text">
   <xsl:with-param name="ParamParagraph" select="." />
   <xsl:with-param name="ParamCellWidth" select="'300px'" />
   <xsl:with-param name="ParamSplits" select="$ParamSplits" />
   <xsl:with-param name="ParamCargo" select="$ParamCargo" />
   <xsl:with-param name="ParamLinks" select="$ParamLinks" />
   <xsl:with-param name="ParamTOCData" select="$ParamTOCData" />
   <xsl:with-param name="ParamSplit" select="$ParamSplit" />
  </xsl:call-template>
 </xsl:template>


 <xsl:template match="wwdoc:LineBreak[./ancestor::wwdoc:Paragraph[(@stylename = 'ErrorList2') or (@stylename = 'BodyContents') or (@stylename = 'BodyContents1')]]" mode="wwmode:textrun">
  <xsl:param name="ParamSplits" />
  <xsl:param name="ParamCargo" />
  <xsl:param name="ParamLinks" />
  <xsl:param name="ParamSplit" />

  <!-- Nothing to do -->
  <!--               -->
 </xsl:template>


 <!-- Paragraph-Tabs-To-Text -->
 <!--                        -->

 <xsl:template name="Paragraph-Tabs-To-Text">
  <xsl:param name="ParamParagraph" />
  <xsl:param name="ParamCellWidth" />
  <xsl:param name="ParamSplits" />
  <xsl:param name="ParamCargo" />
  <xsl:param name="ParamLinks" />
  <xsl:param name="ParamTOCData" />
  <xsl:param name="ParamSplit" />

  <xsl:variable name="VarParagraph" select="$ParamParagraph" />

  <!-- Inspect paragraph info -->
  <!--                        -->
  <xsl:variable name="VarContextRule" select="wwprojext:GetContextRule('Paragraph', $VarParagraph/@stylename, $ParamSplit/@documentID, $VarParagraph/@id)" />

  <!-- Resolve project properties -->
  <!--                            -->
  <xsl:variable name="VarResolvedContextPropertiesAsXML">
   <xsl:call-template name="Properties-ResolveContextRule">
    <xsl:with-param name="ParamDocumentContext" select="$VarParagraph" />
    <xsl:with-param name="ParamProperties" select="$VarContextRule/wwproject:Properties/wwproject:Property" />
    <xsl:with-param name="ParamStyleName" select="$VarParagraph/@stylename" />
    <xsl:with-param name="ParamStyleType" select="'Paragraph'" />
    <xsl:with-param name="ParamContextStyle" select="$VarParagraph/wwdoc:Style" />
   </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="VarResolvedContextProperties" select="msxsl:node-set($VarResolvedContextPropertiesAsXML)/wwproject:Property" />

  <!-- CSS properties -->
  <!--                -->
  <xsl:variable name="VarCSSContextPropertiesAsXML">
   <xsl:call-template name="CSS-TranslateProjectProperties">
    <xsl:with-param name="ParamProperties" select="$VarResolvedContextProperties" />
    <xsl:with-param name="ParamFromAbsoluteURI" select="$ParamSplit/@path" />
    <xsl:with-param name="ParamSplits" select="$ParamSplits" />
   </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="VarCSSContextProperties" select="msxsl:node-set($VarCSSContextPropertiesAsXML)/wwproject:Property" />

  <!-- Collect non-empty text runs -->
  <!--                             -->
  <xsl:variable name="VarTextRuns" select="$VarParagraph/wwdoc:TextRun[count(child::wwdoc:Text[1] | child::wwdoc:Frame[1] | child::wwdoc:Note[1] | child::wwdoc:LineBreak[1] | child::wwdoc:Marker[1]) &gt; 0]" />

  <!-- Text runs exist? -->
  <!--                  -->
  <xsl:for-each select="$VarTextRuns[1]">
   <!-- Eliminate tabs -->
   <!--                -->
   <wwexsldoc:MappingContext>
    <wwexsldoc:MapEntry match="&#9;"></wwexsldoc:MapEntry>

    <!-- Determine position of first text run with a tab in it -->
    <!--                                                       -->
    <xsl:variable name="VarTextRunWithTabIndex">
     <xsl:call-template name="TextRun-With-Tab">
      <xsl:with-param name="ParamTextRun" select="$VarTextRuns[1]" />
      <xsl:with-param name="ParamIndex" select="1" />
     </xsl:call-template>
    </xsl:variable>

    <!-- Emit as table -->
    <!--               -->
    <html:table>
     <html:tr>
      <html:td>
       <xsl:attribute name="style">
        <xsl:text>vertical-align: baseline;</xsl:text>

        <!-- width -->
        <!--       -->
        <xsl:choose>
         <!-- Cell width defined? -->
         <!--                     -->
         <xsl:when test="string-length($ParamCellWidth) &gt; 0">
          <xsl:text> width: </xsl:text>
          <xsl:value-of select="$ParamCellWidth" />
         </xsl:when>

         <!-- Infer cell width from text indent -->
         <!--                                   -->
         <xsl:otherwise>
          <!-- Set width equal to paragraph's text indent? -->
          <!--                                             -->
          <xsl:variable name="VarTextIndent">
           <!-- Text indent defined? -->
           <!--                      -->
           <xsl:variable name="VarContextTextIndent" select="$VarCSSContextProperties[@Name = 'text-indent']/@Value" />
           <xsl:if test="string-length($VarContextTextIndent) &gt; 0">
            <xsl:value-of select="$VarContextTextIndent" />
           </xsl:if>
          </xsl:variable>
          <xsl:variable name="VarTextIndentNumericPrefix" select="wwunits:NumericPrefix($VarTextIndent)" />
          <xsl:variable name="VarTextIndentLessThanZero" select="(string-length($VarTextIndentNumericPrefix) &gt; 0) and (number($VarTextIndentNumericPrefix) &lt; 0)" />
          <xsl:if test="$VarTextIndentLessThanZero">
           <xsl:variable name="VarTextIndentNumberAsUnits" select="wwunits:NumericPrefix($VarTextIndent)" />
           <xsl:variable name="VarTextIndentUnits" select="wwunits:UnitsSuffix($VarTextIndent)" />

           <!-- width -->
           <!--       -->
           <xsl:text> width: </xsl:text>
           <xsl:value-of select="0 - $VarTextIndentNumberAsUnits" />
           <xsl:value-of select="$VarTextIndentUnits" />
          </xsl:if>
         </xsl:otherwise>
        </xsl:choose>
       </xsl:attribute>

       <!-- Emit text runs before the tab -->
       <!--                               -->
       <xsl:for-each select="$VarTextRuns">
        <xsl:variable name="VarTextRun" select="." />

        <!-- Emit text -->
        <!--           -->
        <xsl:if test="position() &lt; $VarTextRunWithTabIndex">
         <xsl:call-template name="TextRun">
          <xsl:with-param name="ParamSplits" select="$ParamSplits" />
          <xsl:with-param name="ParamCargo" select="$ParamCargo" />
          <xsl:with-param name="ParamLinks" select="$ParamLinks" />
          <xsl:with-param name="ParamSplit" select="$ParamSplit" />
          <xsl:with-param name="ParamParagraphID" select="$VarParagraph/@id" />
          <xsl:with-param name="ParamUseCharacterStyles" select="true()" />
          <xsl:with-param name="ParamTextRun" select="$VarTextRun" />
          <xsl:with-param name="ParamEmitAnchorName" select="true()" />
         </xsl:call-template>
        </xsl:if>
       </xsl:for-each>
      </html:td>

      <html:td style="vertical-align: baseline">
       <!-- Emit remaining text runs -->
       <!--                          -->
       <xsl:for-each select="$VarTextRuns">
        <xsl:variable name="VarTextRun" select="." />

        <!-- Emit text -->
        <!--           -->
        <xsl:if test="position() &gt;= $VarTextRunWithTabIndex">
         <xsl:call-template name="TextRun">
          <xsl:with-param name="ParamSplits" select="$ParamSplits" />
          <xsl:with-param name="ParamCargo" select="$ParamCargo" />
          <xsl:with-param name="ParamLinks" select="$ParamLinks" />
          <xsl:with-param name="ParamSplit" select="$ParamSplit" />
          <xsl:with-param name="ParamParagraphID" select="$VarParagraph/@id" />
          <xsl:with-param name="ParamUseCharacterStyles" select="true()" />
          <xsl:with-param name="ParamTextRun" select="$VarTextRun" />
          <xsl:with-param name="ParamEmitAnchorName" select="false()" />
         </xsl:call-template>
        </xsl:if>
       </xsl:for-each>
      </html:td>
     </html:tr>
    </html:table>
   </wwexsldoc:MappingContext>
  </xsl:for-each>
 </xsl:template>


 <!-- TextRun-With-Tab -->
 <!--                  -->

 <xsl:template name="TextRun-With-Tab">
  <xsl:param name="ParamTextRun" />
  <xsl:param name="ParamIndex" />

  <!-- Collect text run text -->
  <!--                       -->
  <xsl:variable name="VarTextRunText">
   <xsl:for-each select="$ParamTextRun/wwdoc:Text">
    <xsl:variable name="VarText" select="." />

    <xsl:value-of select="$VarText/@value" />
   </xsl:for-each>
  </xsl:variable>

  <xsl:choose>
   <!-- Found tab! -->
   <!--            -->
   <xsl:when test="contains($VarTextRunText, '&#9;')">
    <xsl:value-of select="$ParamIndex" />
   </xsl:when>

   <xsl:otherwise>
    <xsl:choose>
     <!-- More text runs? -->
     <!--                 -->
     <xsl:when test="count($ParamTextRun/following-sibling::wwdoc:TextRun[1]) &gt; 0">
      <xsl:call-template name="TextRun-With-Tab">
       <xsl:with-param name="ParamTextRun" select="$ParamTextRun/following-sibling::wwdoc:TextRun[1]" />
       <xsl:with-param name="ParamIndex" select="$ParamIndex + 1" />
      </xsl:call-template>
     </xsl:when>

     <!-- No tab found, so return 0 -->
     <!--                           -->
     <xsl:otherwise>
      <xsl:value-of select="0" />
     </xsl:otherwise>
    </xsl:choose>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
</xsl:stylesheet>
